﻿using UnityEngine;
using System.Collections;

public class CameraScript : MonoBehaviour {

	public float distX = 2f, distYBot = 3f;
	public float cameraSpeedX = 0.1f, cameraSpeedY = 1f;
	public float cameraMaxSpeedX = 20f, cameraMaxSpeedY = 40f;
	public bool moveCamera;

	public float dampTime = 0.15f;
	private Vector3 velocity = Vector3.zero;
//	[SerializeField]
//	private Transform target;

	[SerializeField]
	private Transform myTrans;
	private Rigidbody2D myBody;

	void Awake () {
		InitiateVariables ();
	}
		

	void Update () {
//		CheckIfPlayerOnScreen ();
//		CameraMoveX ();
//		CameraMoveY ();
		Vector3 diff = new Vector3(myTrans.position.x - transform.position.x, myTrans.position.y - transform.position.y, myTrans.position.z - transform.position.z);
		if (diff.magnitude >= 5) {
			Vector3 point = Camera.main.WorldToViewportPoint(myTrans.position);
			Vector3 delta = myTrans.position - Camera.main.ViewportToWorldPoint(new Vector3(0.5f, 0.5f, point.z)); //(new Vector3(0.5, 0.5, point.z));
			Vector3 destination = transform.position + delta;
			transform.position = Vector3.SmoothDamp(transform.position, destination, ref velocity, dampTime);
		}
			
	}



	void CameraMoveX () {
		if (moveCamera) {
			if (Input.GetButton ("Fire2")) {
				Vector2 temp = Camera.main.ScreenToWorldPoint (Input.mousePosition);
				if (Mathf.Abs (transform.position.x - temp.x) > distX) {
					if (transform.position.x - temp.x > 0) {
						if (Mathf.Abs (myBody.velocity.x) <= cameraMaxSpeedX) {
							if (!Input.GetButtonUp ("Fire2")) {
								myBody.velocity = new Vector2 (myBody.velocity.x - cameraSpeedX, 0);
							} else {
								myBody.velocity = new Vector2 (-cameraMaxSpeedX, 0);
							}
						}
					} else {
						if (Mathf.Abs (myBody.velocity.x) <= cameraMaxSpeedX) {
							if (!Input.GetButtonUp ("Fire2")) {
								myBody.velocity = new Vector2 (myBody.velocity.x + cameraSpeedX, 0);
							} else {
								myBody.velocity = new Vector2 (cameraMaxSpeedX, 0);
							}
						}
					}
				} else {
					myBody.velocity = new Vector2 (0, myBody.velocity.y);
				}
			} else {
				if (Mathf.Abs (transform.position.x - myTrans.position.x) > distX) {
					if (transform.position.x - myTrans.position.x > 0) {
						if (Mathf.Abs (myBody.velocity.x) <= cameraMaxSpeedX) {
							myBody.velocity = new Vector2 (myBody.velocity.x - cameraSpeedX, 0);
						} else {
							myBody.velocity = new Vector2 (-cameraMaxSpeedX, 0);
						}
					} else {
						if (Mathf.Abs (myBody.velocity.x) <= cameraMaxSpeedX) {
							myBody.velocity = new Vector2 (myBody.velocity.x + cameraSpeedX, 0);
						} else {
							myBody.velocity = new Vector2 (cameraMaxSpeedX, 0);
						}
					}
				} else {
					myBody.velocity = new Vector2 (0, myBody.velocity.y);
				}
			}
		} else {
			myBody.velocity = new Vector2 (0, myBody.velocity.y);
		}
	}

	void CameraMoveY () {
		if (moveCamera) {
			if (Input.GetButton ("Fire2")) {
				Vector2 temp = Camera.main.ScreenToWorldPoint (Input.mousePosition);
				if (Mathf.Abs (transform.position.y - temp.y) > distYBot) {
					if (transform.position.y - temp.y > 0) {
						if (Mathf.Abs (myBody.velocity.y) <= cameraMaxSpeedY) {
							if (!Input.GetButtonUp ("Fire2")) {
								myBody.velocity = new Vector2 (0, myBody.velocity.y - cameraSpeedY);
							} else {
								myBody.velocity = new Vector2 (0, -cameraMaxSpeedY);
							}
						}
					} else {
						if (Mathf.Abs (myBody.velocity.y) <= cameraMaxSpeedY) {
							if (!Input.GetButtonUp ("Fire2")) {
								myBody.velocity = new Vector2 (0, myBody.velocity.y + cameraSpeedY);
							} else {
								myBody.velocity = new Vector2 (0, cameraMaxSpeedY);
							}
						}
					}
				} else {
					myBody.velocity = new Vector2 (myBody.velocity.x, 0);
				}
			} else {
				if (Mathf.Abs (transform.position.y - myTrans.position.y) > distYBot) {
					if (transform.position.y - myTrans.position.y > 0) {
						if (Mathf.Abs (myBody.velocity.y) <= cameraMaxSpeedY) {
							myBody.velocity = new Vector2 (0, myBody.velocity.y - cameraSpeedY);
						} else {
							myBody.velocity = new Vector2 (0, -cameraMaxSpeedY);
						}
					} else {
						if (Mathf.Abs (myBody.velocity.y) <= cameraMaxSpeedY) {
							myBody.velocity = new Vector2 (0, myBody.velocity.y + cameraSpeedY);
						} else {
							myBody.velocity = new Vector2 (0, cameraMaxSpeedY);
						}
					}
				} else {
					myBody.velocity = new Vector2 (myBody.velocity.x, 0);
				}
			}
		} else {
			myBody.velocity = new Vector2 (myBody.velocity.x, 0);
		}
	}

//	void CheckIfPlayerOnScreen () {
//		Vector3 screenPos = Camera.main.WorldToScreenPoint (transform.position);
//		Vector3 screenPosMT = Camera.main.WorldToScreenPoint (myTrans.position);
//
//		if (Mathf.Abs (screenPos.x - screenPosMT.x) > Screen.width / 2 - 25 && moveCamera) {
//			moveCamera = false;
//		} else {
//			moveCamera = true;
//		}
//	}

	void InitiateVariables () {
		myBody = GetComponent<Rigidbody2D> ();
	}

}
