﻿using UnityEngine;
using System.Collections;

public class WaveLooperScript : MonoBehaviour {

	public float speedMax = 0.3f, speed;
	public float amp, freq;
	public float ampMax, freqMax;

	[SerializeField]
	private PlayerScript pscript;
	private Vector2 offset;
	private Material mat;

	// Use this for initialization
	void Start () {
		mat = GetComponent<Renderer> ().material;
		offset = mat.GetTextureOffset ("_MainTex");
		ampMax = pscript.ampMax;
		freqMax = pscript.freqMax;
	}
	
	// Update is called once per frame
	void Update () {
		amp = pscript.amp;
		freq = pscript.freq;

		mat.SetTextureScale ("_MainTex", new Vector2 (Mathf.Lerp (0.3f, 4, freq / freqMax), 1));
		speed = speedMax * Mathf.Lerp (0.1f, 1f, freq / freqMax);
		transform.localScale = new Vector2 (transform.localScale.x, Mathf.Lerp (0.2f, 1, amp / ampMax));

		offset.x += speed * Time.deltaTime;
		mat.SetTextureOffset ("_MainTex", offset);
	}
		
}
